/*
 * @author: Alex Cappiello
 * @date: 4/6/2012
 *
 * This file is intended to demonstrate the basic implementation of C0 style
 * contracts in C. Note the positions of the statements.
 * Compile using gcc with the -DDEBUG flag.
 *   gcc -DDEBUG annot.c
 */

#include <stdio.h>
#include <stdlib.h>
#include "contracts.h"

int foo(int n) {
  REQUIRES(n > 0); // After the opening {

  n++;

  ENSURES(n > 1); // Before the return. Be careful if you have >1 return.
  return n;
}

int main() {
  printf("%d\n", foo(5));
  return 0;
}
