/*
 * @author: Alex Cappiello
 * @date: 4/6/2012
 *
 * This file is intended to demonstrate a basic example of C pointer arithmetic.
 * Adding a value to a pointer is not the same as adding two ints.
 */

#include <stdio.h>
#include <stdlib.h>

int main() {
  int *p = calloc(10, sizeof(int));

  *(p + 5) = 122; // These two lines are identical.
  p[5] = 122;

  // Show that each address is the same, and then show that the value was set.
  printf("%p %p %d\n", (void*)(&p[5]), (void*)(p + 5), p[5]);

  free(p); // Always free!
  
  return 0;
}
