/*
 * @author: Alex Cappiello
 * @date: 4/6/2012
 *
 * This file is intended to demonstrate a basic example of C casting.
 * Casting "converts" from one data type to another, but there may be unexpected
 * side effects, as shown here.
 */

#include <stdio.h>
#include <stdlib.h>

int main() {
  int *p = malloc(sizeof(int)); // Allocate a single int.
  char *c = (char*)p; // Treat the same 4 bytes as a char array of size 4.

  *c = 'A'; // 0x41
  c[1] = 'B'; // 0x42

  printf("%x\n%c %c\n", *p, *c, c[1]);
  // If the result doesn't make sense, recall little endian byte ordering...

  free(p); // Always free!
  /* Should I also have free(c) here? No! I may have two pointers, but they
     point to the same address. Freeing the same memory twice will segfault! */

  return 0;
}
