/*
 * @author: Alex Cappiello (acappiel)
 * @date: 11/2/12
 *
 * Another casting example, this time with void*. Since a void* is a pointer to
 * something of unknown size, we can't dereference it as is. So, we cast to an
 * int*. Then, we can dereference it. Using void pointers is extremely useful
 * for writing generic code.
 */

#include <stdio.h>
#include <stdlib.h>

int main () {
  void *x = malloc(sizeof(int));
  *(int*)x = 5;
  printf("%d\n", *(int*)x);
  return 0;
}
