/*
 * @author: Alex Cappiello
 * @date: 4/6/2012, updated: 11/16/2012
 *
 * This file is intended to demonstrate basic usage of C macros. Macros can be
 * thought of as like doing a find-replace_all on your code before it is
 * compiled. Not that this is a bit of an oversimplification, as things like
 * string literals are ignored.
 */

#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

#define MOD(X,Y) (X) % (Y) // Style convention is to use ALL CAPS.
#define MOD2(X,Y) X % Y // What's the difference?
#define MAX(a,b) a > b ? a : b
#define MAX2(a, b) ((a) > (b) ? (a) : (b))

int main() {
  printf("%d\n", MOD(2+3,4));
  printf("%d\n", MOD2(2+3,4));

  printf("%d\n", 5 * MAX(4 + 3, 10));
  printf("%d\n", 5 * MAX2(4 + 3, 10));

  printf("%d %d\n", INT_MIN, INT_MAX);

  return 0;
}

