/*
 * Example taken from the lecture notes.
 * First, compile with gcc outofbounds.c and run.
 * Then, compile with gcc -g outofbounds.c and run valgrind ./a.out.
 * Valgrind will tell you that you have illegal memory access and compiling
 * with -g allows valgrind to tell you what line number caused this.
 */

#include <stdio.h>
#include <stdlib.h>

int main() {
  int* A = malloc(sizeof(int));
  A[0] = 0; /* ok - A[0] is like *A */
  A[1] = 1; /* error - not allocated */
  A[317] = 29; /* error - not allocated */
  A[-1] = 32; /* error - not allocated */
  printf("A[-1] = %d\n", A[-1]);
  return 0;
}
