/*
 * @author: Alex Cappiello
 * @date: 4/6/2012
 *
 * This file is intended to show that we can go WAY out of bounds during memory
 * access.
 * Compile as:
 *   gcc -std=c99 outofbounds2.c
 * c99 mode is needed to declare a variable in a loop initialization.
 */

#include <stdio.h>
#include <stdlib.h>

int main() {
  int *p = malloc(sizeof(int));

  // How far will this loop go before segfaulting?
  for (int i = 0; i < 100000; i++) {
    // I can assign p[i] = i inside of the printf call.
    printf("%d\n", p[i] = i);
  }

  return 0;
}
