/*
 * @author: Alex Cappiello (acappiel)
 * @date: 11/2/2012
 *
 * Code for string concatenation, where we append the string in src
 * to the string in dest. We assume there is memory and do not allocate new
 * memory.
 *
 * The first one is what we wrote in recitation.
 * The second is my evil implementation.
 */

#include <stdio.h>

char *strcat (char *dest, char *src) {
  char *p = dest;
  while (*dest != '\0')
    dest++;

  while (*src != '\0') {
    *dest = *src;
    dest++;
    src++;
  }

  *dest = '\0';

  return p;
}

/*
 * Just because you can write this does NOT mean you should. In fact, it's
 * dreadful style. Don't write this. What is interesting is why it works.
 * It follows the same logic as the code above, but it actually does computation
 * in the loop condition. Recall that in C, when checking conditions, false/true
 * is more like 0/!0. So, in each iteration, the while loop cases on the ascii
 * value of the character pointed to by dest. When we hit the NULL terminator,
 * ascii value 0, the loop stops.
 */
char *strcatmine (char *dest, char *src) {
  char *p = dest;
  while (*++dest);
  while (*dest++ = *src++);
  return p;
}

int main () {
  char A[11];
  A[10] = 'c';

  A[0] = 'h'; A[1] = 'e'; A[2] = 'l'; A[3] = 'l'; A[4] = 'o'; A[5] = '\0';
  printf("%s\n", A);
  strcat(A, "world");
  printf("%s\n", A);

  return 0;
}
