/*
 * @author: Alex Cappiello
 * @date: 4/6/2012
 *
 * This file is intended to show usage of the wrapper functions for malloc (and
 * calloc) provided in xalloc.h. When malloc fails to allocate memory, it
 * returns NULL, but we want the program to abort instead. This is extremely
 * rare, but also important to always check for. The wrapper function is used so
 * that you don't need to do this yourself every time.  Compile as: gcc xalloc.c
 * xsafe.c
 */

#include <stdio.h>
#include <stdlib.h>
#include "xalloc.h"

int main() {
  void *p = xmalloc(sizeof(int));

  printf("%p\n", p); // print the address.

  free(p);

  return 0;
}
